<?php
/*
 +-------------------------------------------------------------------------+
 | Copyright (C) 2008 The Cacti Group                                      |
 |                                                                         |
 | This program is free software; you can redistribute it and/or           |
 | modify it under the terms of the GNU General Public License             |
 | as published by the Free Software Foundation; either version 2          |
 | of the License, or (at your option) any later version.                  |
 |                                                                         |
 | This program is distributed in the hope that it will be useful,         |
 | but WITHOUT ANY WARRANTY; without even the implied warranty of          |
 | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           |
 | GNU General Public License for more details.                            |
 +-------------------------------------------------------------------------+
 | Cacti: The Complete RRDTool-based Graphing Solution                     |
 +-------------------------------------------------------------------------+
 | This code is designed, written, and maintained by the Cacti Group. See  |
 | about.php and/or the AUTHORS file for specific developer information.   |
 +-------------------------------------------------------------------------+
 | http://www.cacti.net/                                                   |
 +-------------------------------------------------------------------------+
*/

function plugin_init_tools() {
	global $plugin_hooks;
	$plugin_hooks['config_arrays']['tools'] = 'tools_config_arrays';
	$plugin_hooks['draw_navigation_text']['tools'] = 'tools_draw_navigation_text';
}

function tools_version () {
	return array( 'name' 	=> 'tools',
			'version' 	=> '0.3',
			'longname'	=> 'Network Tools',
			'author'	=> 'Jimmy Conner',
			'homepage'	=> 'http://cactiusers.org',
			'email'	=> 'jimmy@sqmail.org',
			'url'		=> 'http://cactiusers.org/cacti/versions.php'
			);
}

function tools_config_arrays () {
	global $user_auth_realms, $user_auth_realm_filenames, $menu;

	$user_auth_realm_filenames['tools.php'] = 8;
	$temp = $menu["Utilities"]['logout.php'];
	unset($menu["Utilities"]['logout.php']);
	$menu["Utilities"]['plugins/tools/tools.php'] = "Network Tools";
	$menu["Utilities"]['logout.php'] = $temp;

}
function tools_draw_navigation_text ($nav) {
	$nav["tools.php:"] = array("title" => "Network Tools", "mapping" => "index.php:", "url" => "tools.php", "level" => "1");
	$nav["tools.php:servicecheck"] = array("title" => "Network Tools", "mapping" => "index.php:", "url" => "tools.php", "level" => "1");
	$nav["tools.php:snmpwalk"] = array("title" => "Network Tools", "mapping" => "index.php:", "url" => "tools.php", "level" => "1");
	return $nav;
}

?>