<?php
/*
 +-------------------------------------------------------------------------+
 | Copyright (C) 2008 The Cacti Group                                      |
 |                                                                         |
 | This program is free software; you can redistribute it and/or           |
 | modify it under the terms of the GNU General Public License             |
 | as published by the Free Software Foundation; either version 2          |
 | of the License, or (at your option) any later version.                  |
 |                                                                         |
 | This program is distributed in the hope that it will be useful,         |
 | but WITHOUT ANY WARRANTY; without even the implied warranty of          |
 | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           |
 | GNU General Public License for more details.                            |
 +-------------------------------------------------------------------------+
 | Cacti: The Complete RRDTool-based Graphing Solution                     |
 +-------------------------------------------------------------------------+
 | This code is designed, written, and maintained by the Cacti Group. See  |
 | about.php and/or the AUTHORS file for specific developer information.   |
 +-------------------------------------------------------------------------+
 | http://www.cacti.net/                                                   |
 +-------------------------------------------------------------------------+
*/


chdir('../../');

include("./include/auth.php");
include_once("./lib/snmp.php");
include_once("./lib/utility.php");

$action = "";
if (isset($_POST['action'])) {
	$action = $_POST['action'];
} else if (isset($_GET['action'])) {
	$action = $_GET['action'];
}

if (isset($_POST['host']) && IsValidHost($_POST['host']))
	$host = $_POST['host'];
else
	$host = '127.0.0.1';
if (isset($_POST['oid']) && IsValidOID($_POST['oid']))
	$oid = $_POST['oid'];
else
	$oid = '.1';
if (isset($_POST['community']) && IsValidCommunity($_POST['community']))
	$community = $_POST['community'];
else
	$community = 'public';

include_once("./include/top_header.php");

show_tools ();

switch ($action) {
	case 'servicecheck': 
		ShowServiceCheck();
		break;
	case 'snmpwalk': 
		WalkHost();
		break;
	case 'edit':

		break;
	case 'delete':

		break;
	default:
		break;
}

include_once("./include/bottom_footer.php");


function show_tools () {
	global $action, $host, $oid, $community;
	print "<br><br><br><center><table width=500 bgcolor=black cellpadding=1 cellspacing=0><tr><td><table width='100%' bgcolor=white cellspacing=3><tr><td>";
	print "<form method=POST action=tools.php>";
	print "<table width='100%'><tr><td valign=center width=50>Host</td><td valign=center>";
	print "<input type=text size=20 value='$host' name=host id=host><br><br></center></td></tr>";
	print "<tr><td colspan=2><hr width='100%'></td></tr>";
//SNMP Walk
	print "<tr><td><input type=radio name=action value=snmpwalk";
	if ($action == 'snmpwalk')
		print " checked";
	print "></td><td><h3>SNMP Walk</h3>";
	print "<table cellspacing=0 cellpadding=0 corder=0><tr><td>OID</td><td><input type=text size=20 value='$oid' name=oid id=oid></td></tr>";
	print "<tr><td>Community&nbsp;&nbsp;&nbsp;</td><td><input type=text size=20 value='$community' name=community id=community></td></tr></table>";
	print "</td><tr>";
	print "<tr><td colspan=2><hr width='100%'></td></tr>";

// Service Check
	print "<tr><td><input type=radio name=action value=servicecheck";
	if ($action == 'servicecheck')
		print " checked";
	print "></td><td><h3>Service Check</h3><input type=checkbox name=http checked>HTTP<input type=checkbox name=ftp checked>FTP<input type=checkbox name=pop3 checked>POP3<input type=checkbox name=smtp checked>SMTP</td><tr>";
	print "<tr><td colspan=2><hr width='100%'></td></tr>";
	print "<tr><td></td><td><input type=submit value=Submit></td></tr>";
	print "</table></form>";
	print "</td></tr></table></td></tr></table>";
}


function ShowServiceCheck () {
	global $host;
	if (!isset($_POST['host']))
		return;
	print "<br><br><br><center><table width=500 bgcolor=black cellpadding=1 cellspacing=0><tr><td><table width='100%' bgcolor=white><tr><td>";
	$results = array();
	$results[] = ServiceCheck($host, 'http');
	$results[] = ServiceCheck($host, 'ftp');
	$results[] = ServiceCheck($host, 'pop3');
	$results[] = ServiceCheck($host, 'smtp');

	print "<center><table><tr><td colspan=5><center><h3>Service Results for $host</h3></center></td></tr><tr><td></td><td><b><u>Service</u></b>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td><td><b><u>Port</u></b>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td><td><b><u>Result</u></b>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td><td><b><u>Time</u></b>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td></tr>";
	foreach ($results as $r) {
		print "<tr><td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td><td>" . $r['service'] . "</td><td>" . $r['port'] . "</td><td>" . $r['result'] . "</td><td>" . $r['time'] . "</td></tr>";
	}
	print "</table></center>";
	print "</td></tr></table></td></tr></table>";

}

function IsValidHost($host) {
	if(preg_match("/^((([0-9]{1,3}\.){3}[0-9]{1,3})|([0-9a-z-.]{0,61})?\.[a-z]{2,4})$/i", $host)) 
		return 1;
	return 0;
}

function IsValidOID($oid) {
	if(preg_match("/^([0-9\.]{0,61})$/i", $oid)) 
		return 1;
	return 0;
}

function IsValidCommunity($community) {
	if(preg_match("/^([0-9a-zA-Z\.]{0,61})$/i", $community)) 
		return 1;
	return 0;
}

function WalkHost () {
	global $config, $host, $oid, $community;
	if (!isset($_POST['host']))
		return;

	$host = strtolower($host);
	snmp_set_quick_print(0);

	$snmp_auth_username = '';
	$snmp_auth_password = '';
	$snmp_auth_protocol = '';
	$snmp_priv_passphrase = '';
	$snmp_priv_protocol = '';
	$snmp_context = '';

	$snmp_port = 161;
	$snmp_timeout = 1000;

	$a = cacti_snmp_walk($host, $community, $oid, 2, $snmp_auth_username, $snmp_auth_password, $snmp_auth_protocol, $snmp_priv_passphrase, $snmp_priv_protocol, $snmp_context, $snmp_port, $snmp_timeout, read_config_option("snmp_retries"), SNMP_POLLER);

	print "<br><br><br><center><table bgcolor=black cellpadding=1 cellspacing=0><tr><td><table width='100%' bgcolor=white><tr><td>";

	print "<center><table border=1px><tr><td colspan=2 bgcolor=white><center><h3>SNMP Walk Results for $host</h3></center></td></tr>";
	foreach ($a as $val) {
		print "<tr><td>" . $val['oid'] . "</td><td>" . $val['value'] . "</td></tr>";
	}
	print "</table></center>";
	print "</td></tr></table></td></tr></table>";
}


function ServiceCheck($host, $service, $port='', $timeout = 10) {
	$host = strtolower($host);

	switch($service) {
		case 'http': 
			$Request = "HEAD / HTTP/1.0\r\nUser-Agent: Service Check\r\nHost: $host\r\n\r\n";
			$OkResults = array("200\D+OK", "200\D+Document\s+Follows", "302", "301");
			if(!is_numeric($port)) $port = 80;
			break;

		case 'ftp': 
			$OkResults = array("220");
			$Request = '';
			if(!is_numeric($port)) $port = 21;
			break;
	
		case 'smtp': 
			$OkResults = array("220");
			$Request = '';
			if(!is_numeric($port)) $port = 25;
			break;

		case 'pop3': 
			$OkResults = array("\\+OK");
			$Request = '';
			if(!is_numeric($port)) $port = 110;
			break;
	}

	list($MSec, $Sec) = explode(" ", microtime());
	$TimeBegin = (double) $MSec + (double) $Sec;
	$Socket = @fsockopen($host, $port, $error_number, $error, $timeout);

	list($MSec, $Sec) = explode(" ", microtime());
	$TimeEnd = (double) $MSec + (double) $Sec;
	$Time = number_format($TimeEnd - $TimeBegin, 3);
	// Check port

	if (is_resource($Socket)) {
		if ($Request != "") {
			fputs($Socket, $Request);
			stream_set_timeout($Socket, $timeout);
		}
		if (!feof($Socket)) {
			$Response = fgets($Socket, 4096);
			stream_set_timeout($Socket, $timeout);
		}
		$Result = "Failed";
		$Error  = $Response;

		foreach($OkResults as $exp_result) {
			if (preg_match("/$exp_result/",$Response)) {
				$Error = "";
				$Result = "Ok";
			}
		}
		fclose($Socket);
	 } else { 
		$Result = "Failed";
		$Error = ((!$error) ? "Time out" : $error);
	 }

	 return array(
			'host'   => $host,
			'service'=> $service,
			'port'   => $port,
			'result' => $Result,
			'time'   => $Time,
			'error'  => $Error
		 );

}


?>
